"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");exports.__esModule=true;exports.default=void 0;var _babelHelperVueJsxMergeProps=_interopRequireDefault(require("@vue/babel-helper-vue-jsx-merge-props"));var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));var _icon=_interopRequireDefault(require("../icon"));var _cell=_interopRequireDefault(require("../cell"));var _shared=require("../cell/shared");var _event=require("../utils/dom/event");var _resetScroll=require("../utils/dom/reset-scroll");var _utils=require("../utils");var _createNamespace=(0,_utils.createNamespace)('field'),createComponent=_createNamespace[0],bem=_createNamespace[1];var _default=createComponent({inheritAttrs:false,props:(0,_extends2.default)({},_shared.cellProps,{error:Boolean,readonly:Boolean,autosize:[Boolean,Object],leftIcon:String,rightIcon:String,clearable:Boolean,labelClass:null,labelWidth:[Number,String],labelAlign:String,inputAlign:String,errorMessage:String,errorMessageAlign:String,type:{type:String,default:'text'}}),data:function data(){return{focused:false};},watch:{value:function value(){this.$nextTick(this.adjustSize);}},mounted:function mounted(){this.format();this.$nextTick(this.adjustSize);},computed:{showClear:function showClear(){return this.clearable&&this.focused&&this.value!==''&&(0,_utils.isDef)(this.value)&&!this.readonly;},listeners:function listeners(){var listeners=(0,_extends2.default)({},this.$listeners,{input:this.onInput,keypress:this.onKeypress,focus:this.onFocus,blur:this.onBlur});delete listeners.click;return listeners;},labelStyle:function labelStyle(){var labelWidth=this.labelWidth;if(labelWidth){return{width:(0,_utils.addUnit)(labelWidth)};}}},methods:{focus:function focus(){if(this.$refs.input){this.$refs.input.focus();}},blur:function blur(){if(this.$refs.input){this.$refs.input.blur();}},format:function format(target){if(target===void 0){target=this.$refs.input;}
if(!target){return;}
var _target=target,value=_target.value;var maxlength=this.$attrs.maxlength;if(this.type==='number'&&(0,_utils.isDef)(maxlength)&&value.length>maxlength){value=value.slice(0,maxlength);target.value=value;}
return value;},onInput:function onInput(event){if(event.target.composing){return;}
this.$emit('input',this.format(event.target));},onFocus:function onFocus(event){this.focused=true;this.$emit('focus',event);if(this.readonly){this.blur();}},onBlur:function onBlur(event){this.focused=false;this.$emit('blur',event);(0,_resetScroll.resetScroll)();},onClick:function onClick(event){this.$emit('click',event);},onClickLeftIcon:function onClickLeftIcon(event){this.$emit('click-left-icon',event);},onClickRightIcon:function onClickRightIcon(event){this.$emit('click-right-icon',event);},onClear:function onClear(event){(0,_event.preventDefault)(event);this.$emit('input','');this.$emit('clear',event);},onKeypress:function onKeypress(event){if(this.type==='number'){var keyCode=event.keyCode;var allowPoint=String(this.value).indexOf('.')===-1;var isValidKey=keyCode>=48&&keyCode<=57||keyCode===46&&allowPoint||keyCode===45;if(!isValidKey){(0,_event.preventDefault)(event);}}
if(this.type==='search'&&event.keyCode===13){this.blur();}
this.$emit('keypress',event);},adjustSize:function adjustSize(){var input=this.$refs.input;if(!(this.type==='textarea'&&this.autosize)||!input){return;}
input.style.height='auto';var height=input.scrollHeight;if((0,_utils.isObj)(this.autosize)){var _this$autosize=this.autosize,maxHeight=_this$autosize.maxHeight,minHeight=_this$autosize.minHeight;if(maxHeight){height=Math.min(height,maxHeight);}
if(minHeight){height=Math.max(height,minHeight);}}
if(height){input.style.height=height+'px';}},renderInput:function renderInput(){var h=this.$createElement;var inputSlot=this.slots('input');if(inputSlot){return h("div",{"class":bem('control',this.inputAlign)},[inputSlot]);}
var inputProps={ref:'input',class:bem('control',this.inputAlign),domProps:{value:this.value},attrs:(0,_extends2.default)({},this.$attrs,{readonly:this.readonly}),on:this.listeners,directives:[{name:'model',value:this.value}]};if(this.type==='textarea'){return h("textarea",(0,_babelHelperVueJsxMergeProps.default)([{},inputProps]));}
return h("input",(0,_babelHelperVueJsxMergeProps.default)([{"attrs":{"type":this.type}},inputProps]));},renderLeftIcon:function renderLeftIcon(){var h=this.$createElement;var showLeftIcon=this.slots('left-icon')||this.leftIcon;if(showLeftIcon){return h("div",{"class":bem('left-icon'),"on":{"click":this.onClickLeftIcon}},[this.slots('left-icon')||h(_icon.default,{"attrs":{"name":this.leftIcon}})]);}},renderRightIcon:function renderRightIcon(){var h=this.$createElement;var slots=this.slots;var showRightIcon=slots('right-icon')||this.rightIcon;if(showRightIcon){return h("div",{"class":bem('right-icon'),"on":{"click":this.onClickRightIcon}},[slots('right-icon')||h(_icon.default,{"attrs":{"name":this.rightIcon}})]);}}},render:function render(){var _bem;var h=arguments[0];var slots=this.slots,labelAlign=this.labelAlign;var scopedSlots={icon:this.renderLeftIcon};if(slots('label')){scopedSlots.title=function(){return slots('label');};}
return h(_cell.default,{"attrs":{"icon":this.leftIcon,"size":this.size,"title":this.label,"center":this.center,"border":this.border,"isLink":this.isLink,"required":this.required,"clickable":this.clickable,"titleStyle":this.labelStyle,"titleClass":[bem('label',labelAlign),this.labelClass],"arrowDirection":this.arrowDirection},"class":bem((_bem={error:this.error,disabled:this.$attrs.disabled},_bem["label-"+labelAlign]=labelAlign,_bem['min-height']=this.type==='textarea'&&!this.autosize,_bem)),"scopedSlots":scopedSlots,"on":{"click":this.onClick}},[h("div",{"class":bem('body')},[this.renderInput(),this.showClear&&h(_icon.default,{"attrs":{"name":"clear"},"class":bem('clear'),"on":{"touchstart":this.onClear}}),this.renderRightIcon(),slots('button')&&h("div",{"class":bem('button')},[slots('button')])]),this.errorMessage&&h("div",{"class":bem('error-message',this.errorMessageAlign)},[this.errorMessage])]);}});exports.default=_default;