"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");exports.__esModule=true;exports.default=void 0;var _babelHelperVueJsxMergeProps=_interopRequireDefault(require("@vue/babel-helper-vue-jsx-merge-props"));var _deepClone=require("../utils/deep-clone");var _utils=require("../utils");var _number=require("../utils/format/number");var _event=require("../utils/dom/event");var _touch=require("../mixins/touch");var DEFAULT_DURATION=200;var MOMENTUM_DURATION=1000;var MOMENTUM_LIMIT_TIME=300;var MOMENTUM_LIMIT_DISTANCE=15;var _createNamespace=(0,_utils.createNamespace)('picker-column'),createComponent=_createNamespace[0],bem=_createNamespace[1];function getElementTranslateY(element){var style=window.getComputedStyle(element);var transform=style.transform||style.webkitTransform;var translateY=transform.slice(7,transform.length-1).split(', ')[5];return Number(translateY);}
function isOptionDisabled(option){return(0,_utils.isObj)(option)&&option.disabled;}
var _default2=createComponent({mixins:[_touch.TouchMixin],props:{valueKey:String,allowHtml:Boolean,className:String,itemHeight:Number,defaultIndex:Number,visibleItemCount:Number,initialOptions:{type:Array,default:function _default(){return[];}}},data:function data(){return{offset:0,duration:0,options:(0,_deepClone.deepClone)(this.initialOptions),currentIndex:this.defaultIndex};},created:function created(){if(this.$parent.children){this.$parent.children.push(this);}
this.setIndex(this.currentIndex);},destroyed:function destroyed(){var children=this.$parent.children;if(children){children.splice(children.indexOf(this),1);}},watch:{defaultIndex:function defaultIndex(){this.setIndex(this.defaultIndex);}},computed:{count:function count(){return this.options.length;},baseOffset:function baseOffset(){return this.itemHeight*(this.visibleItemCount-1)/2;}},methods:{onTouchStart:function onTouchStart(event){this.touchStart(event);if(this.moving){var translateY=getElementTranslateY(this.$refs.wrapper);this.offset=Math.min(0,translateY-this.baseOffset);this.startOffset=this.offset;}else{this.startOffset=this.offset;}
this.duration=0;this.transitionEndTrigger=null;this.touchStartTime=Date.now();this.momentumOffset=this.startOffset;},onTouchMove:function onTouchMove(event){this.moving=true;this.touchMove(event);if(this.direction==='vertical'){(0,_event.preventDefault)(event,true);}
this.offset=(0,_number.range)(this.startOffset+this.deltaY,-(this.count*this.itemHeight),this.itemHeight);var now=Date.now();if(now-this.touchStartTime>MOMENTUM_LIMIT_TIME){this.touchStartTime=now;this.momentumOffset=this.offset;}},onTouchEnd:function onTouchEnd(){var distance=this.offset-this.momentumOffset;var duration=Date.now()-this.touchStartTime;var allowMomentum=duration<MOMENTUM_LIMIT_TIME&&Math.abs(distance)>MOMENTUM_LIMIT_DISTANCE;if(allowMomentum){this.momentum(distance,duration);return;}
var index=this.getIndexByOffset(this.offset);this.moving=false;this.duration=DEFAULT_DURATION;this.setIndex(index,true);},onTransitionEnd:function onTransitionEnd(){this.stopMomentum();},onClickItem:function onClickItem(index){if(this.moving){return;}
this.duration=DEFAULT_DURATION;this.setIndex(index,true);},adjustIndex:function adjustIndex(index){index=(0,_number.range)(index,0,this.count);for(var i=index;i<this.count;i++){if(!isOptionDisabled(this.options[i]))return i;}
for(var _i=index-1;_i>=0;_i--){if(!isOptionDisabled(this.options[_i]))return _i;}},getOptionText:function getOptionText(option){return(0,_utils.isObj)(option)&&this.valueKey in option?option[this.valueKey]:option;},setIndex:function setIndex(index,userAction){var _this=this;index=this.adjustIndex(index)||0;this.offset=-index*this.itemHeight;var trigger=function trigger(){if(index!==_this.currentIndex){_this.currentIndex=index;if(userAction){_this.$emit('change',index);}}};if(this.moving){this.transitionEndTrigger=trigger;}else{trigger();}},setValue:function setValue(value){var options=this.options;for(var i=0;i<options.length;i++){if(this.getOptionText(options[i])===value){return this.setIndex(i);}}},getValue:function getValue(){return this.options[this.currentIndex];},getIndexByOffset:function getIndexByOffset(offset){return(0,_number.range)(Math.round(-offset/this.itemHeight),0,this.count-1);},momentum:function momentum(distance,duration){var speed=Math.abs(distance/duration);distance=this.offset+speed/0.002*(distance<0?-1:1);var index=this.getIndexByOffset(distance);this.duration=MOMENTUM_DURATION;this.setIndex(index,true);},stopMomentum:function stopMomentum(){this.moving=false;this.duration=0;if(this.transitionEndTrigger){this.transitionEndTrigger();this.transitionEndTrigger=null;}},genOptions:function genOptions(){var _this2=this;var h=this.$createElement;var optionStyle={height:this.itemHeight+"px"};return this.options.map(function(option,index){var text=_this2.getOptionText(option);var data={style:optionStyle,class:['van-ellipsis',bem('item',{disabled:isOptionDisabled(option),selected:index===_this2.currentIndex})],on:{click:function click(){_this2.onClickItem(index);}}};if(_this2.allowHtml){data.domProps={innerHTML:text};}
return h("li",(0,_babelHelperVueJsxMergeProps.default)([{},data]),[_this2.allowHtml?'':text]);});}},render:function render(){var h=arguments[0];var wrapperStyle={transform:"translate3d(0, "+(this.offset+this.baseOffset)+"px, 0)",transitionDuration:this.duration+"ms",transitionProperty:this.duration?'all':'none',lineHeight:this.itemHeight+"px"};return h("div",{"class":[bem(),this.className],"on":{"touchstart":this.onTouchStart,"touchmove":this.onTouchMove,"touchend":this.onTouchEnd,"touchcancel":this.onTouchEnd}},[h("ul",{"ref":"wrapper","style":wrapperStyle,"class":bem('wrapper'),"on":{"transitionend":this.onTransitionEnd}},[this.genOptions()])]);}});exports.default=_default2;